<template>
    <div class="px-2">

        <h2>Dashboard</h2>

        <div class="row mx-auto my-2">
            <div class="col-sm-6 col-md-4 my-1 px-1">
                <div class="card h-100">
                    <div class="card-body d-flex flex-column justify-content-end">
                        <span class="text-muted">Withdraw Requests</span>
                        <h1 class="card-title">
                            <span class="h5 text-muted" v-if="loading">
                                <i class="fas fa-spinner fa-spin"></i>
                            </span>
                            <span v-else>
                                {{ pendingWithdrawRequests }}
                            </span>
                        </h1>
                    </div>
                    <div class="card-footer text-right">
                        <router-link class="card-link" to="/admin/withdraw-requests">Manage</router-link>
                    </div>
                </div>
            </div>
            <div class="col-sm-6 col-md-4 my-1 px-1">
                <div class="card h-100">
                    <div class="card-body d-flex flex-column justify-content-end">
                        <span class="text-muted">Advertiser</span>
                        <h1 class="card-title">
                            <span>
                                Deposits
                            </span>
                        </h1>
                    </div>
                    <div class="card-footer text-right">
                        <router-link class="card-link" to="/admin/advertiser-deposit">Manage</router-link>
                    </div>
                </div>
            </div>
        </div>

    </div>
</template>

<script>
    export default {
        data: function () {
            return {
                // Stats
                pendingWithdrawRequests: 0,

                // Loading Flag
                loading: false,

                // Status flags
                success: false,
                fail: false,

            }
        },
        methods: {
            loadDashboardStats: function () {
                // Set the loading flag
                this.loading = true;

                // Clear status flags
                this.success = false;
                this.fail = false;

                // Make a request to the API
                axios.get('/api/admin/dashboard')
                    .then(response => {
                        this.pendingWithdrawRequests = response.data.pending_withdraw_requests;
                    })
                    .catch(error => {
                        if (error.response) {
                            // The request was made and the server responded with a status code
                            // that falls out of the range of 2xx
                            console.log(error.response.status);

                            // Handle validation errors
                            if (error.response.status === 401) {
                                this.fail = {
                                    'message': 'Unauthorized'
                                };
                            } else {
                                this.fail = {
                                    message: 'Something Went Wrong. Check your connection and try again.'
                                };
                            }

                        } else if (error.request) {
                            // The request was made, but no response was received
                            console.log(error.request);

                            this.fail = {
                                message: 'Something Went Wrong. Check your connection and try again.'
                            };

                        } else {
                            // Something happened in setting up the request that triggered an error
                            console.log('Error', error.message);

                            this.fail = {
                                message: 'Something Went Wrong. Check your connection and try again.'
                            };
                        }
                    })
                    .then(e => {
                        // Hide the loading
                        this.loading = false;
                    });
            }
        },
        mounted() {
            console.log('Admin - Home mounted.');

            // Load dashboard stats
            this.loadDashboardStats();
        }
    }
</script>
